Debian Bug report logs - #684342
screen: Only can reattach to 4.0.3 screen if session is already detached

version graph

Package: screen; Maintainer for screen is Axel Beckert <abe@debian.org>; Source for screen is src:screen.

Reported by: Axel Beckert <abe@debian.org>

Date: Wed, 8 Aug 2012 21:54:02 UTC

Severity: serious

Tags: patch

Found in version screen/4.1.0~20120320gitdb59704-6

Fixed in version screen/4.1.0~20120320gitdb59704-7

Done: Axel Beckert <abe@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, abe@debian.org:
Bug#684342; Package screen. (Wed, 08 Aug 2012 21:54:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Axel Beckert <abe@debian.org>:
New Bug report received and forwarded. Copy sent to abe@debian.org. (Wed, 08 Aug 2012 21:54:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Axel Beckert <abe@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: screen: Only can reattach to 4.0.3 screen if session is already detached
Date: Wed, 8 Aug 2012 23:51:35 +0200 (CEST)
Package: screen
Version: 4.1.0~20120320gitdb59704-6
Severity: serious

While reattaching works fine after applying the patch from
http://bugs.debian.org/683228, remotely detaching a still attached
screen (as necessary before a reattach) shows the same behaviour as
without patch:

The screen client hangs infinitely and no key press goes through to the
server except Ctrl-C. No output is shown on the (trying to be)
client-side in either case.

Inside the screen session the message "Message 12296 of 12336 bytes too
small" is seen.

-- System Information:
Debian Release: wheezy/sid
  APT prefers testing
  APT policy: (500, 'testing'), (200, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 3.4-trunk-amd64 (SMP w/1 CPU core)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages screen depends on:
ii  dpkg          1.16.4.3
ii  install-info  4.13a.dfsg.1-10
ii  libc6         2.13-33
ii  libpam0g      1.1.3-7.1
ii  libtinfo5     5.9-10

screen recommends no packages.

Versions of packages screen suggests:
ii  byobu    5.16-1
ii  iselect  1.4.0-1

-- no debconf information



Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#684342; Package screen. (Wed, 08 Aug 2012 23:33:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Axel Beckert <abe@debian.org>:
Extra info received and forwarded to list. (Wed, 08 Aug 2012 23:33:05 GMT) Full text and rfc822 format available.

Message #10 received at 684342@bugs.debian.org (full text, mbox):

From: Axel Beckert <abe@debian.org>
To: 684342@bugs.debian.org
Cc: Debian Bug Tracking System E-Mail Control Server <control@bugs.debian.org>
Subject: Re: Bug#684342: screen: Only can reattach to 4.0.3 screen if session is already detached
Date: Thu, 9 Aug 2012 01:29:21 +0200
tag 684342 + patch pending
kthxbye

Axel Beckert wrote:
> While reattaching works fine after applying the patch from
> http://bugs.debian.org/683228, remotely detaching a still attached
> screen (as necessary before a reattach) shows the same behaviour as
> without patch:

The following patch (modulo whitespace due to copy & paste) seems to
fix this issue:

--- a/debian/patches/60-644788-screen-4.1.0-4.0.3-interoperability.patch
+++ b/debian/patches/60-644788-screen-4.1.0-4.0.3-interoperability.patch
@@ -94,7 +100,9 @@ Index: screen-4.1.0~20120320gitdb59704/attacher.c
 +WriteOldMessage(struct msg *m)
 +{
 +  sleep(1); /* give the server some time to reopen the pipe */
-+  if (m->type == MSG_ATTACH && m->m.attach.detachfirst == MSG_ATTACH)
++  if (m->type == MSG_ATTACH && (m->m.attach.detachfirst == MSG_ATTACH ||
++                                m->m.attach.detachfirst == MSG_DETACH ||
++                                m->m.attach.detachfirst == MSG_POW_DETACH))
 +    {
 +      struct old_msg old_m;
 +      int s;

Still leaves a non-working "screen -d" (4.0.3 interoperability only)
open. Likely needs another copy-the-date-from-the-new-message block
inside WriteOldMessage(). But compared to "screen -r", it can be
aborted with Ctrl-C and hence is a less critical issue.

Will test this patch for a few days and if I don't find any other
issues, upload a new package to unstable.

		Regards, Axel
-- 
 ,''`.  |  Axel Beckert <abe@debian.org>, http://people.debian.org/~abe/
: :' :  |  Debian Developer, ftp.ch.debian.org Admin
`. `'   |  1024D: F067 EA27 26B9 C3FC 1486  202E C09E 1D89 9593 0EDE
  `-    |  4096R: 2517 B724 C5F6 CA99 5329  6E61 2FF9 CD59 6126 16B5



Added tag(s) pending and patch. Request was from Axel Beckert <abe@debian.org> to control@bugs.debian.org. (Wed, 08 Aug 2012 23:33:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#684342; Package screen. (Tue, 14 Aug 2012 10:45:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Axel Beckert <abe@debian.org>:
Extra info received and forwarded to list. (Tue, 14 Aug 2012 10:45:05 GMT) Full text and rfc822 format available.

Message #17 received at 684342@bugs.debian.org (full text, mbox):

From: Axel Beckert <abe@debian.org>
To: 684342@bugs.debian.org
Subject: Re: Bug#684342: screen: Only can reattach to 4.0.3 screen if session is already detached
Date: Tue, 14 Aug 2012 12:41:27 +0200
Axel Beckert wrote:
> > While reattaching works fine after applying the patch from
> > http://bugs.debian.org/683228, remotely detaching a still attached
> > screen (as necessary before a reattach) shows the same behaviour as
> > without patch:

JFTR: Resizing the terminal (i.e. the WINCH signal) is not propagated
either yet.

		Regards, Axel
-- 
 ,''`.  |  Axel Beckert <abe@debian.org>, http://people.debian.org/~abe/
: :' :  |  Debian Developer, ftp.ch.debian.org Admin
`. `'   |  1024D: F067 EA27 26B9 C3FC 1486  202E C09E 1D89 9593 0EDE
  `-    |  4096R: 2517 B724 C5F6 CA99 5329  6E61 2FF9 CD59 6126 16B5



Information forwarded to debian-bugs-dist@lists.debian.org, Axel Beckert <abe@debian.org>:
Bug#684342; Package screen. (Sat, 15 Sep 2012 18:18:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to Axel Beckert <abe@debian.org>. (Sat, 15 Sep 2012 18:18:03 GMT) Full text and rfc822 format available.

Message #22 received at 684342@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: Axel Beckert <abe@debian.org>, 684342@bugs.debian.org
Subject: Re: Bug#684342: screen: Only can reattach to 4.0.3 screen if session is already detached
Date: Sat, 15 Sep 2012 20:15:40 +0200
[Message part 1 (text/plain, inline)]
On Thu, Aug  9, 2012 at 01:29:21 +0200, Axel Beckert wrote:

> Will test this patch for a few days and if I don't find any other
> issues, upload a new package to unstable.
> 
What's the status?

Cheers,
Julien
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#684342; Package screen. (Sat, 15 Sep 2012 18:42:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Axel Beckert <abe@debian.org>:
Extra info received and forwarded to list. (Sat, 15 Sep 2012 18:42:04 GMT) Full text and rfc822 format available.

Message #27 received at 684342@bugs.debian.org (full text, mbox):

From: Axel Beckert <abe@debian.org>
To: Julien Cristau <jcristau@debian.org>
Cc: 684342@bugs.debian.org
Subject: Re: Bug#684342: screen: Only can reattach to 4.0.3 screen if session is already detached
Date: Sat, 15 Sep 2012 20:39:55 +0200
Hi,

Julien Cristau wrote:
> On Thu, Aug  9, 2012 at 01:29:21 +0200, Axel Beckert wrote:
> > Will test this patch for a few days and if I don't find any other
> > issues, upload a new package to unstable.
>
> What's the status?

Updated patch with detach working is in git.

Didn't get window resizing (WINCH signal) working though. But there is
a workaround for that since detaching and then reattaching again
helps. I'm currently documenting this via NEWS.Debian. Expect an
updated upload this weekend.

I'm though no more sure if going with the patch is really the better
solution. It's not fully working but will last in the package the
whole wheezy lifetime while my preinst/postinst hack would just happen
during the upgrade itself. Then OTOH I found no side effects of the
patch in day to day use with 4.1.0-client to 4.1.0-server.

And since at least those from the release team who argued about my
solution for initial issue seem to prefer the patch as solution, I'll
ask for a freeze exception for the upcoming -7 upload.

		Regards, Axel
-- 
 ,''`.  |  Axel Beckert <abe@debian.org>, http://people.debian.org/~abe/
: :' :  |  Debian Developer, ftp.ch.debian.org Admin
`. `'   |  1024D: F067 EA27 26B9 C3FC 1486  202E C09E 1D89 9593 0EDE
  `-    |  4096R: 2517 B724 C5F6 CA99 5329  6E61 2FF9 CD59 6126 16B5



Reply sent to Axel Beckert <abe@debian.org>:
You have taken responsibility. (Sun, 16 Sep 2012 12:51:05 GMT) Full text and rfc822 format available.

Notification sent to Axel Beckert <abe@debian.org>:
Bug acknowledged by developer. (Sun, 16 Sep 2012 12:51:05 GMT) Full text and rfc822 format available.

Message #32 received at 684342-close@bugs.debian.org (full text, mbox):

From: Axel Beckert <abe@debian.org>
To: 684342-close@bugs.debian.org
Subject: Bug#684342: fixed in screen 4.1.0~20120320gitdb59704-7
Date: Sun, 16 Sep 2012 12:47:48 +0000
Source: screen
Source-Version: 4.1.0~20120320gitdb59704-7

We believe that the bug you reported is fixed in the latest version of
screen, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 684342@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Axel Beckert <abe@debian.org> (supplier of updated screen package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sun, 16 Sep 2012 13:42:12 +0200
Source: screen
Binary: screen
Architecture: source amd64
Version: 4.1.0~20120320gitdb59704-7
Distribution: unstable
Urgency: low
Maintainer: Axel Beckert <abe@debian.org>
Changed-By: Axel Beckert <abe@debian.org>
Description: 
 screen     - terminal multiplexer with VT100/ANSI terminal emulation
Closes: 684342
Changes: 
 screen (4.1.0~20120320gitdb59704-7) unstable; urgency=low
 .
   * Extend 60-644788-screen-4.1.0-4.0.3-interoperability.patch:
     + Add support for detaching (Closes: #684342)
     + Document remaining issues in debian/NEWS
Checksums-Sha1: 
 4ea7d8ce82636dfa7b04bd5852cca70e286725db 1458 screen_4.1.0~20120320gitdb59704-7.dsc
 0a3505c2add599640ef57bf024a4918057eec3a6 60313 screen_4.1.0~20120320gitdb59704-7.debian.tar.gz
 c0e91d96e1b500820ecaa7803d9b544714cf37ad 669622 screen_4.1.0~20120320gitdb59704-7_amd64.deb
Checksums-Sha256: 
 88c15e8db5de037b83bba7bd81e43fc11af4389d1158b12775af3ef18bcdbaa4 1458 screen_4.1.0~20120320gitdb59704-7.dsc
 248a81c978530d63dd2e4c340541761f4cd9823fdca6764d548d7d0bf6315f97 60313 screen_4.1.0~20120320gitdb59704-7.debian.tar.gz
 e3500c6aac14f00fd2bc1bbf016561fd02a13848bf0987b69ed334ab28e48b48 669622 screen_4.1.0~20120320gitdb59704-7_amd64.deb
Files: 
 70f7ebf10d4c0548b680f0c1ed65bc53 1458 misc optional screen_4.1.0~20120320gitdb59704-7.dsc
 e28651fb36b3bacc9d7b2da85de8d41b 60313 misc optional screen_4.1.0~20120320gitdb59704-7.debian.tar.gz
 2ab81f4fe6855d4c98018c7d894651e4 669622 misc optional screen_4.1.0~20120320gitdb59704-7_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iEYEARECAAYFAlBVwVUACgkQwJ4diZWTDt7omACeKW3hizc2LngLsu5qdbAiOlVs
x3EAn1/YDX3RVIXevc00lgCc1iBwNX8I
=YsmO
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 15 Oct 2012 07:26:35 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 16:56:32 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.